#include <stdio.h>
#include <upc.h>

int main(int argc, char **argv)
{
  static shared int x[THREADS];
  int *xloc;
  int coords[2], coords_plus_1_1[2], coords_minus_1_1[2], codims[2];
 
  xloc = (int*) &(x[MYTHREAD]);

  codims[0]=2;
  codims[1]=THREADS/codims[0];
  coords[0]=MYTHREAD / codims[1];
  coords[1]=MYTHREAD % codims[1];
/* The following macro maps two process coordinates into the */
/* linear range of thread ranks which is between 0 THREADS-1 */
#define idx(c0,c1) ((c0)*codims[1]+(c1))

  /* Coordinates of the diagonal neighbor (+1,+1) */ 
  coords_plus_1_1[0] = (coords[0]+1) % codims[0];
  coords_plus_1_1[1] = (coords[1]+1) % codims[1];
  /* Coordinates of the diagonal neighbor (-1,-1) */ 
  coords_minus_1_1[0] = (coords[0]-1+codims[0]) % codims[0];
  coords_minus_1_1[1] = (coords[1]-1+codims[1]) % codims[1];

  *xloc = 1000 + MYTHREAD;
  /* or x[MYTHREAD] = 1000 + MYTHREAD; */

  if (MYTHREAD == 0) {
    printf("myrank= %d Number of processes = %d = %d*%d (with UPC)\n",
            MYTHREAD, THREADS, codims[0], codims[1]); 
  } 

  upc_barrier 20; /* any number */

  printf("myrank= %d c0=%d c1=%d x[%d,%d]=%d x[%d,%d]=%d x[%d,%d]=%d\n",
          MYTHREAD, coords[0], coords[1],
          coords_minus_1_1[0], coords_minus_1_1[1], x[idx(coords_minus_1_1[0],coords_minus_1_1[1])],
          coords[0], coords[1], x[idx(coords[0],coords[1])],
          coords_plus_1_1[0], coords_plus_1_1[1], x[idx(coords_plus_1_1[0],coords_plus_1_1[1])]);

  return 0;
}
